/* GCC */
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

const int NMAX = 51000;

int N , P , parent[NMAX] , cycle_begin , cycle_end , cur_answer , global_answer;
int F[NMAX] , G[NMAX] , MulPref[NMAX] , MulSuf[NMAX] , son[NMAX] ;
vector <int> graph[NMAX];
bool banned[NMAX] , visited[NMAX];

bool dfs_find_cycle(int v)
{
  banned[v] = true;
  for (int i = 0 ; i < graph[v].size() ; i ++ )
  {
    int u = graph[v][i];
    if ( u == parent[v] )
        continue;

    if ( banned[u] )
    {
        cycle_begin = u;
        cycle_end = v;
        return true;
    };
    parent[u] = v;
    if ( dfs_find_cycle(u) )
        return true;
  };
  return false;
};

int dfs(int v , bool delete_edge)
{
    int start = v;
    stack<pair <int , bool> > S;
    S.push(make_pair(v , false));
    while ( !S.empty() )
    {
      v = S.top().first;
      bool type = S.top().second;
      S.pop();
      if ( !type )
      {
          visited[v] = true;
          S.push(make_pair(v , true));
          G[v] = 1;
          for (int i = 0 ; i < graph[v].size() ; i ++ )
          {
            int u = graph[v][i];
            if ( u == parent[v] || (delete_edge && banned[v] && banned[u]) || (!delete_edge && banned[u]) )
                continue;
            parent[u] = v;
            S.push(make_pair(u , false));
          };
      } else
      {
          int cnt = 0;
           for (int i = 0 ; i < graph[v].size() ; i ++ )
           {
             int u = graph[v][i];
             if ( u == parent[v] || (delete_edge && banned[v] && banned[u]) || (!delete_edge && banned[u]) )
                 continue;
             G[v] = (G[v] * F[u]) % P;
             son[cnt ++ ] = u;
           };
            MulPref[0] = 1;
            MulSuf[cnt + 1] = 1;
            for (int i = 1 ; i <= cnt ; i ++ )
            MulPref[i] = (MulPref[i - 1] * F[son[i - 1]]) % P;

            for (int i = cnt ; i >= 1 ; i -- )
                MulSuf[i] = (MulSuf[i + 1] * F[son[i - 1]]) % P;
            F[v] = G[v];
            for (int i = 1 ; i <= cnt ; i ++ )
            {
              int temp = MulPref[i - 1];
              temp = (temp * G[son[i - 1]]) % P;
              temp = (temp * MulSuf[i + 1]) % P;
              F[v] = (F[v] + temp) % P;
            };
      };
    };
    return F[start];
};

int main()
{
    freopen("museum.in","r",stdin);
    freopen("museum.out","w",stdout);
    scanf("%d %d",&N,&P);
    for (int i = 1 ; i <= N ; i ++ )
    {
      int v , u;
      scanf("%d %d",&v,&u);
      graph[v].push_back(u);
      graph[u].push_back(v);
    };

    dfs_find_cycle(1);

    for (int i = 1 ; i <= N ; i ++ )
        banned[i] = visited[i] = false;
    for (int i = cycle_end ; i != cycle_begin ; i = parent[i] )
        banned[i] = true ;
    banned[cycle_begin] = true;
    cur_answer = 1;
    for (int i = 1 ; i <= N ; i ++ )
        if ( !visited[i] && !banned[i] )
            cur_answer = (cur_answer * dfs(i , false) ) % P;
    global_answer = (global_answer + 2 * cur_answer) % P;

    for (int i = 1 ; i <= N ; i ++ )
        banned[i] = visited[i] = false;
    banned[cycle_begin] = banned[cycle_end] = true;
    cur_answer = 1;
    for (int i = 1 ; i <= N ; i ++ )
        if ( !visited[i] && !banned[i] )
            cur_answer = (cur_answer * dfs(i , false) ) % P;
    global_answer = (global_answer + cur_answer) % P;

     for (int i = 1 ; i <= N ; i ++ )
        banned[i] = visited[i] = false;
    banned[cycle_begin] = banned[cycle_end] = true;
    cur_answer = dfs(cycle_begin , true);
    global_answer = (global_answer + cur_answer) % P;
    printf("%d\n",global_answer);
    return 0;
}
