/* GCC */
#include <stdio.h>
#include <algorithm>
#include <vector>
using namespace std;

// Input
const int DEBUG = 0;
const char* in = "museum.in";
const char* out = "museum.out";
const int maxN = 2560;
// Algorithm
int N, P;
vector<int> adj[maxN];
int cycle[maxN], cl = 0;
int parent[maxN];
bool lock[maxN] = {false,};
int b1, b2;
int dyn[maxN][2];

bool findCycle(int v, int prev){
     parent[v] = prev;
     for(int i = 0; i < (int) adj[v].size(); i++){
       int w = adj[v][i];
       if (w == prev) continue;
       if (parent[w] == -1) return findCycle(w, v);
       else{
            while(v != w){
              cycle[cl++] = v;
              v = parent[v];
            }
            cycle[cl++] = v;
            return true;
       }
     }
     return false;
}

void calc(int v, int prev = 0){
     lock[v] = true;
     dyn[v][0] = dyn[v][1] = 1;
     for(int i = 0; i < (int) adj[v].size(); i++){
       int w = adj[v][i];
       if (w != prev && !lock[w] && !((w == b1 && v == b2)|| (w == b2 && v == b1)) ){
           calc(w, v);
           dyn[v][0] = dyn[v][0]*dyn[w][0]+dyn[v][1]*dyn[w][1];
           dyn[v][1] = dyn[v][1]*dyn[w][0];
       }
     }
}

int calc(){
    int ans = 1;
    for(int i = 1; i <= N; i++){
      if (!lock[i]){
        calc(i);
        ans = (ans*dyn[i][0])%P;
      }
    }
    return ans;
}

int main(){
    if (!DEBUG) freopen(in, "r", stdin);
    if (!DEBUG) freopen(out, "w", stdout);
    scanf("%d %d", &N, &P);
    for(int i = 0; i < maxN; i++){
      parent[i] = -1;
      cycle[i] = -1;
    }
    for(int i = 0; i < N; i++){
      int u, v;
      scanf("%d %d", &u, &v);
      adj[u].push_back(v);
      adj[v].push_back(u);
    }
    findCycle(1, 0);
    int ans = 0;
    // Close one edge, don't use it
    b1 = cycle[0], b2 = cycle[1];
    for(int i = 0; i < maxN; i++) lock[i] = false;
    ans = (ans+calc())%P;
    // Close one edge, use it
    b1 = -1; b2 = -1; 
    for(int i = 0; i < maxN; i++) lock[i] = false;
    lock[cycle[0]] = lock[cycle[1]] = true;
    ans = (ans+calc())%P;
    // Use all the cycle
    for(int i = 0; i < maxN; i++) lock[i] = false;
    for(int i = 0; i < cl; i++) lock[cycle[i]] = true;
    ans = (ans+2*calc())%P;
    printf("%d\n", ans);
    if (DEBUG) system("pause");
}
